var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { combineLatest } from "rxjs";
import { distinctUntilChanged, map } from "rxjs/operators";
import { itemAsPage$ } from "ht-data";
var EntityClient = /** @class */ (function () {
    function EntityClient() {
    }
    EntityClient.prototype.dataArrayWithSelected$ = function (id$, dataArray$, selected$) {
        var userId$ = id$;
        var placelinePage$ = selected$.pipe(distinctUntilChanged(), map(function (data) {
            return data ? [data] : null;
        })); //todo take query from placeline
        var array$ = combineLatest(placelinePage$, userId$, dataArray$, function (placelinePage, userId, dataArray) {
            var filteredData = dataArray.filter(function (user) {
                return userId ? user.id == userId : true;
            });
            return placelinePage && userId ? placelinePage : filteredData;
        });
        return array$;
    };
    EntityClient.prototype.pageDataWithSelected$ = function (id$, pageData$, selected$) {
        // const userId$ = id$;
        var placelinePage$ = selected$.pipe(itemAsPage$());
        var newPageData$ = combineLatest(placelinePage$, id$, pageData$, function (placelinePage, userId, pageData) {
            if (!pageData)
                return pageData;
            var placelineResults = placelinePage ? placelinePage.results : null;
            var filteredData = pageData.results.filter(function (user) {
                return userId ? user.id == userId : true;
            });
            var results = placelineResults && userId ? placelineResults : filteredData;
            var count = userId ? 0 : pageData.count;
            return __assign({}, pageData, { results: results, count: count });
        });
        return newPageData$;
    };
    EntityClient.prototype.getPageFromEntity = function (item$) {
        return item$;
    };
    return EntityClient;
}());
export { EntityClient };
//# sourceMappingURL=entity-client.js.map