import * as fromAccount from "../../reducers/account-reducer";
import { ApiStoreService } from "../../global/store-provider";
import { AccountUserClient } from "./account-user-client";
import { MemberShipsClient } from "./memberships-all-client";
import * as fromAccounts from "../../dispatchers/accounts-dispatcher";
import { htClientService } from "../../global/client";
var AccountsClient = /** @class */ (function () {
    function AccountsClient() {
        var api = htClientService.getInstance().api.accountUser;
        this.api = api;
        this.store = ApiStoreService.getInstance();
        this.store.addReducer("accounts", fromAccount.reducer);
        this.accountUser = new AccountUserClient({ store: this.store, api: api });
        this.memberships = new MemberShipsClient({ store: this.store, api: api });
    }
    AccountsClient.prototype.setToken = function (token) {
        this.store.dispatch(new fromAccounts.SetKey(token));
    };
    return AccountsClient;
}());
export { AccountsClient };
//# sourceMappingURL=accounts-client.js.map