import { getFirstDataMixin } from "../../mixins/get-first-data";
import { listQueryMixin } from "../../mixins/entity-query";
import { getQueryDataMixin } from "../../mixins/get-data";
import { clientSubMixin } from "../../mixins/client-subscription";
import * as fromAction from "../../dispatchers/actions-dispatcher";
import * as fromRoot from "../../reducers";
var ActionsGraph = /** @class */ (function () {
    function ActionsGraph(_a) {
        var dateRange = _a.dateRange, store = _a.store, dateParam = _a.dateParam, api = _a.api;
        this.updateStrategy = "once";
        this.pollDuration = 10000;
        this.store = store;
        this.query$ = store.select(fromRoot.getActionsGraphQuery);
        this.active$ = this.store.select(fromRoot.getActionsGraphActive);
        this.loading$ = store.select(fromRoot.getActionsGraphLoading);
        this.data$ = store.select(fromRoot.getActionsGraph);
        this.api$ = function (query) { return api.graph(query); };
        this.dateRange = dateRange;
        this.dateParam = dateParam;
    }
    ActionsGraph.prototype.setActive = function (active) {
        if (active === void 0) { active = true; }
        this.store.dispatch(new fromAction.SetGraphActive(active));
        if (!active)
            this.setLoading(false);
    };
    ActionsGraph.prototype.setQuery = function () {
    };
    ActionsGraph.prototype.getDefaultQuery = function () {
        return {};
    };
    ;
    ActionsGraph.prototype.setData = function (data) {
        this.store.dispatch(new fromAction.SetGraph(data));
    };
    ActionsGraph.prototype.firstDataEffect = function () {
        this.setLoading(false);
    };
    ActionsGraph.prototype.setLoading = function (loading) {
        if (loading === void 0) { loading = true; }
        this.store.dispatch(new fromAction.SetGraphLoading(!!loading));
    };
    ActionsGraph.prototype.clearData = function () {
        this.setData(null);
        this.setActive(false);
    };
    ActionsGraph.prototype.destroy = function () {
        this.clearData();
        this.dataSub.unsubscribe();
    };
    return ActionsGraph;
}());
export { ActionsGraph };
export var ActionsGraphClient = clientSubMixin(getQueryDataMixin(getFirstDataMixin(listQueryMixin(ActionsGraph))));
//# sourceMappingURL=actions-graph.js.map