var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { listQueryMixin } from "../../mixins/entity-query";
import { getFirstDataMixin } from "../../mixins/get-first-data";
import { listAllClientSubMixin } from "../../mixins/list-all-client-sub";
import { getAllPageDataMixin } from "../../mixins/get-data";
import { EntityAllItemsClient } from "../../base/all-items.client";
import * as fromRoot from "../../reducers";
import * as fromAction from "../../dispatchers/actions-dispatcher";
var ActionsIndexAll = /** @class */ (function (_super) {
    __extends(ActionsIndexAll, _super);
    function ActionsIndexAll(_a) {
        var dateRange = _a.dateRange, store = _a.store, dateParam = _a.dateParam, api = _a.api;
        var _this = _super.call(this) || this;
        _this.store = store;
        _this.api$ = function (query) { return api.allPages(api.index(query)); };
        _this.dateRange = dateRange;
        _this.dateParam = dateParam;
        _this.query$ = _this.store.select(fromRoot.getActionsListQuery);
        _this.dataEntities$ = _this.store.select(fromRoot.getActionsListAllFiltered);
        _this.active$ = _this.store.select(fromRoot.getActionsListAllActive);
        _this.loading$ = _this.store.select(fromRoot.getActionsListAllLoading);
        return _this;
        // this.data$ = combineLatest(
        //   this.dataBehaviour$.asObservable(),
        //   this.filter$
        // ).pipe(
        //   map(([allData, filterFun]) => {
        //     console.log("alldata", allData);
        //     return filterFun && allData ? filterFun(allData) : allData
        //   })
        // )
    }
    ActionsIndexAll.prototype.setActive = function (isActive) {
        if (isActive === void 0) { isActive = true; }
        this.store.dispatch(new fromAction.SetListAllActive(isActive));
        if (!isActive)
            this.setLoading(false);
    };
    ActionsIndexAll.prototype.setQuery = function (query) {
        this.store.dispatch(new fromAction.SetListQuery(query));
    };
    ActionsIndexAll.prototype.addData = function (data) {
        this.store.dispatch(new fromAction.AddListAll(data));
    };
    ;
    ActionsIndexAll.prototype.setData = function (data) {
        this.store.dispatch(new fromAction.SetListAll(data));
    };
    ActionsIndexAll.prototype.setLoading = function (loading) {
        this.store.dispatch(new fromAction.SetListAllLoading(loading));
    };
    ActionsIndexAll.prototype.clearQueryKey = function (key) {
        this.store.dispatch(new fromAction.ClearQueryKey(key));
    };
    ActionsIndexAll.prototype.setDataMap = function (mapFunc) {
        this.store.dispatch(new fromAction.SetListAllDataMap(mapFunc));
    };
    ActionsIndexAll.prototype.clearData = function () {
        this.setActive(false);
        this.setData(null);
    };
    return ActionsIndexAll;
}(EntityAllItemsClient));
export { ActionsIndexAll };
;
export var ActionsIndexAllClient = listAllClientSubMixin(getAllPageDataMixin(getFirstDataMixin(listQueryMixin(ActionsIndexAll))));
//# sourceMappingURL=actions-list-all-client.js.map