var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { combineLatest } from "rxjs";
import * as fromRoot from "../../reducers";
import * as fromSegmentsDispatcher from "../../dispatchers/segments-dispatcher";
import * as fromUsersDispatcher from "../../dispatchers/user-dispatcher";
import { EntityItemClient } from "../../base/item-client";
import { getIdQueryDataMixin } from "../../mixins/get-data";
import { itemQueryMixin } from "../../mixins/entity-query";
import { clientSubMixin } from "../../mixins/client-subscription";
import { getFirstDataMixin } from "../../mixins/get-first-data";
import { distinctUntilChanged, map } from "rxjs/operators";
var UsersPlaceline = /** @class */ (function (_super) {
    __extends(UsersPlaceline, _super);
    function UsersPlaceline(_a) {
        var store = _a.store, api = _a.api;
        var _this = _super.call(this) || this;
        _this.name = "users placeline";
        _this.updateStrategy = "live";
        _this.api$ = function (id, query) { return api.placeline(id, query); };
        _this.store = store;
        _this.query$ = _this.store.select(fromRoot.getUsersPlacelineQuery);
        _this.actionId$ = _this.getQueryType('action_id');
        _this.data$ = _this.store.select(fromRoot.getUsersUsersData);
        _this.loading$ = _this.store.select(fromRoot.getUsersPlacelineLoading);
        _this.id$ = _this.store.select(fromRoot.getUsersPlacelineId);
        _this.segmentsState$ = _this.store.select(fromRoot.getSegmentsState);
        _this.segmentSelectedId$ = _this.store.select(fromRoot.getSegmentsSelectedId);
        _this.segmentResetId$ = _this.store.select(fromRoot.getSegmentsResetMapId);
        _this.hasData$ = combineLatest(_this.id$, _this.query$).pipe(map(function (_a) {
            var id = _a[0], query = _a[1];
            // console.log("here", id, query, this.validQueryData([id, query || {}]));
            return !!_this.validQueryData([id, query || {}]);
        }), distinctUntilChanged()
        // share
        );
        return _this;
        // this.init()
    }
    ;
    UsersPlaceline.prototype.getQueryType = function (type) {
        return this.query$.pipe(map(function (query) {
            return query ? query[type] : null;
        }), distinctUntilChanged());
    };
    UsersPlaceline.prototype.setData = function (data) {
        this.store.dispatch(new fromUsersDispatcher.SetUserData(data));
    };
    UsersPlaceline.prototype.setLoading = function (data) {
        this.store.dispatch(new fromUsersDispatcher.SetPlacelineLoading(data));
    };
    UsersPlaceline.prototype.setId = function (id) {
        this.store.dispatch(new fromUsersDispatcher.SetPlacelineId(id));
        if (!id)
            this.setLoading(false);
    };
    UsersPlaceline.prototype.toggleId = function (userId) {
        this.store.dispatch(new fromUsersDispatcher.TogglePlacelineId(userId));
    };
    UsersPlaceline.prototype.setQuery = function (query) {
        this.store.dispatch(new fromUsersDispatcher.SetPlacelineQuery(query));
    };
    UsersPlaceline.prototype.setSegmentSelectedId = function (segmentId) {
        this.store.dispatch(new fromSegmentsDispatcher.SetSelectedId(segmentId));
    };
    UsersPlaceline.prototype.setSegmentResetMapId = function (segmentId) {
        this.store.dispatch(new fromSegmentsDispatcher.SetResetMapId(segmentId));
    };
    UsersPlaceline.prototype.getMapData$ = function () {
        // return dataWithSelectedId$(this.data$, this.segmentSelectedId$, [
        //   "segments"
        // ]);
    };
    UsersPlaceline.prototype.validQueryData = function (_a) {
        var id = _a[0], query = _a[1];
        return !!id || query.action_id || query.action_unique_id;
    };
    UsersPlaceline.prototype.clearData = function () {
        this.setData(null);
        this.setLoading(false);
        this.setQuery({});
        this.setId(null);
    };
    return UsersPlaceline;
}(EntityItemClient));
export { UsersPlaceline };
export var UsersPlacelineClient = clientSubMixin(getIdQueryDataMixin(getFirstDataMixin(itemQueryMixin(UsersPlaceline))));
//# sourceMappingURL=users-placeline-client.js.map