"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var entity_query_1 = require("../../mixins/entity-query");
var list_all_client_sub_1 = require("../../mixins/list-all-client-sub");
var get_data_1 = require("../../mixins/get-data");
var get_first_data_1 = require("../../mixins/get-first-data");
var rxjs_1 = require("rxjs");
var ht_data_1 = require("ht-data");
var ActionsHeatmap = /** @class */ (function () {
    function ActionsHeatmap(_a) {
        var dateRange = _a.dateRange, dateParam = _a.dateParam, api = _a.api;
        this.queryBehaviour$ = new rxjs_1.BehaviorSubject({});
        this.query$ = this.queryBehaviour$.asObservable();
        this.loadingState$ = new rxjs_1.BehaviorSubject(false);
        this.loading$ = this.loadingState$.asObservable();
        this.dataState$ = new rxjs_1.BehaviorSubject(null);
        this.data$ = this.dataState$.asObservable();
        this.active$ = new rxjs_1.BehaviorSubject(false);
        this.dataArray$ = this.data$.pipe(ht_data_1.PageResults$);
        this.api$ = function (query) { return api.allPages(api.heatmap(query)); };
        this.dateRange = dateRange;
        this.dateParam = dateParam;
    }
    ActionsHeatmap.prototype.setActive = function (active) {
        if (active === void 0) { active = true; }
        this.active$.next(active);
        if (!active)
            this.setLoading(false);
    };
    ActionsHeatmap.prototype.setQuery = function (query) {
        if (query === void 0) { query = {}; }
        this.queryBehaviour$.next(query);
    };
    ActionsHeatmap.prototype.getDefaultQuery = function () {
        return { page_size: 300 };
    };
    ;
    ActionsHeatmap.prototype.firstDataEffect = function (data) {
        if ((data && !data.next) || !data) {
            this.setLoading(false);
        }
    };
    ActionsHeatmap.prototype.setLoading = function (isLoading) {
        this.loadingState$.next(isLoading);
    };
    ActionsHeatmap.prototype.setData = function (data) {
        this.dataState$.next(data);
    };
    ActionsHeatmap.prototype.addData = function (data) {
        this.dataState$.next(data);
    };
    ActionsHeatmap.prototype.clearData = function () {
        this.setActive(false);
        this.setData(null);
    };
    return ActionsHeatmap;
}());
exports.ActionsHeatmap = ActionsHeatmap;
exports.ActionsHeatmapClient = list_all_client_sub_1.listAllClientSubMixin(get_data_1.getAllPageDataMixin(get_first_data_1.getFirstDataMixin(entity_query_1.listQueryMixin(ActionsHeatmap))));
//# sourceMappingURL=actions-heatmap-client.js.map