import { Observable } from "rxjs/Observable";
import { ApiType } from "../interfaces";
import { Page } from "ht-models";
import { HtRequest } from "../global/request";
export declare class HtBaseApi {
    base: string;
    constructor(base: string);
    readonly request: HtRequest;
    get<T>(id: string, query?: {}): Observable<T>;
    index<T>(query?: {}): Observable<T>;
    summary<T>(query?: {}): Observable<T>;
    heatmap<T>(query?: {}): Observable<T>;
    api$<T>(path: any, query?: {}, options?: {}): Observable<T>;
    postApi$<T>(path: string, body: any, options?: {}): Observable<T>;
    placeline<T>(id: any, query?: {}): Observable<T>;
    all$<T>(query: any, apiType?: ApiType): Observable<Page<T>>;
    allPages<T = any>(api$: any, options?: {}): any;
    analytics(query: any): Observable<any>;
}
