import { Action } from "../store/models";
import { IAction, IActionStatusGraph, Page, IActionsSummary } from "ht-models";
export declare const SET_ACTIONS_LIST = "[ACTIONS] set actions list";
export declare const SET_ACTIONS_LIST_QUERY = "[ACTIONS] set actions list query";
export declare const CLEAR_ACTION_QUERY_KEY = "[ACTIONS] clear list query key";
export declare const ADD_ACTIONS_LIST_QUERY = "[ACTIONS] add actions list query";
export declare const SET_ACTIONS_LIST_ACTIVE = "[ACTIONS] set actions list active";
export declare const SET_ACTIONS_LIST_LOADING = "[ACTIONS] set actions list loading";
export declare const SET_ACTIONS_LIST_ALL = "[ACTIONS] set actions list all";
export declare const ADD_ACTIONS_LIST_ALL = "[ACTIONS] add actions list all";
export declare const SET_ACTIONS_LIST_ALL_ACTIVE = "[ACTIONS] set actions list all active";
export declare const SET_ACTIONS_LIST_ALL_LOADING = "[ACTIONS] set actions list all loading";
export declare const SET_ACTIONS_LIST_ALL_DATA_MAP = "[ACTIONS] set actions list all data map";
export declare const SET_ACTIONS_GRAPH = "[ACTIONS] set actions graph";
export declare const SET_ACTIONS_GRAPH_QUERY = "[ACTIONS] set actions graph query";
export declare const ADD_ACTIONS_GRAPH_QUERY = "[ACTIONS] add actions graph query";
export declare const SET_ACTIONS_GRAPH_LOADING = "[ACTIONS] set actions graph loading";
export declare const SET_ACTIONS_GRAPH_ACTIVE = "[ACTIONS] set actions graph active";
export declare const SET_ACTIONS_SUMMARY = "[ACTIONS] set actions summary";
export declare const SET_ACTIONS_SUMMARY_ACTIVE = "[ACTIONS] set actions summary active";
export declare const ADD_ACTIONS_SUMMARY_QUERY = "[ACTIONS] actions summary query";
export declare const SET_ACTIONS_SUMMARY_QUERY = "[ACTIONS] add set actions summary query";
export declare const SET_ACTIONS_SUMMARY_LOADING = "[ACTIONS] set actions summary loading";
export declare class SetList implements Action {
    payload: Page<IAction>;
    readonly type: string;
    constructor(payload: Page<IAction>);
}
export declare class SetListQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class AddListQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class ClearQueryKey implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare class SetListActive implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload?: boolean | string);
}
export declare class SetListLoading implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload?: boolean | string);
}
export declare class SetListAll implements Action {
    payload: Page<IAction>;
    readonly type: string;
    constructor(payload: Page<IAction>);
}
export declare class AddListAll implements Action {
    payload: Page<IAction>;
    readonly type: string;
    constructor(payload: Page<IAction>);
}
export declare class SetListAllLoading implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload: boolean);
}
export declare class SetListAllActive implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload: boolean | string);
}
export declare class SetListAllDataMap implements Action {
    payload: (data) => any;
    readonly type: string;
    constructor(payload: (data) => any);
}
export declare class SetGraph implements Action {
    payload: IActionStatusGraph[] | null;
    readonly type: string;
    constructor(payload: IActionStatusGraph[] | null);
}
export declare class SetGraphQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class SetGraphLoading implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class SetGraphActive implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class AddGraphQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class SetSummary implements Action {
    payload: IActionsSummary;
    readonly type: string;
    constructor(payload: IActionsSummary);
}
export declare class AddSummaryQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class SetSummaryQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class SetSummaryLoading implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class SetSummaryActive implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload?: boolean | string);
}
export declare type All = SetList | SetListQuery | SetListActive | AddListQuery | ClearQueryKey | SetListLoading | SetListAll | AddListAll | SetListAllLoading | SetListAllActive | SetListAllDataMap | SetGraph | SetGraphLoading | SetGraphQuery | AddGraphQuery | SetGraphActive | SetSummary | SetSummaryActive | SetSummaryLoading | SetSummaryQuery | AddSummaryQuery;
