import { Action } from "../store/models";
import { IUserAnalytics, IUser, Page, IUserListSummary, AllData, IUserPlaceline } from "ht-models";
import { ApiType } from "../interfaces";
export declare const SET_USER_DATA = "[USERS] set user data";
export declare const SET_PLACELINE_ID = "[USERS] set placeline id";
export declare const TOGGLE_PLACELINE_ID = "[USERS] toggle placeline id";
export declare const SET_PLACELINE_QUERY = "[USERS] set placeline query";
export declare const ADD_PLACELINE_QUERY = "[USERS] add placeline query";
export declare const SET_PLACELINE_LOADING = "[USERS] set placeline loading";
export declare const SET_LIST_ACTIVE = "[USERS] set list active";
export declare const SET_LIST_ID = "[USERS] set list id";
export declare const SET_LIST_QUERY = "[USERS] set list query";
export declare const ADD_LIST_QUERY = "[USERS] add list query";
export declare const CLEAR_QUERY_KEY = "[USERS] clear query key";
export declare const TOGGLE_LIST_ID = "[USERS] toggle list id";
export declare const SET_USERS_ANALYTICS_PAGE = "[USERS] set user analytics page";
export declare const SET_USERS_ANALYTICS_ID = "[USERS] set analytics id";
export declare const SET_USERS_ANALYTICS_QUERY = "[USERS] set analytics query";
export declare const SET_USERS_ANALYTICS_LOADING = "[USERS] set analytics loading";
export declare const SET_USERS_LIST_DATA_MAP = "[USERS] set users list data map";
export declare const SET_MARKERS_ACTIVE = "[USERS] set markerS active";
export declare const SET_USERS_ANALYTICS_ALL = "[USERS] set users analytics all";
export declare const ADD_USERS_ANALYTICS_ALL = "[USERS] add users analytics all";
export declare const SET_USERS_ANALYTICS_ALL_QUERY = "[USERS] add analytics all query";
export declare const ADD_USERS_ANALYTICS_ALL_QUERY = "[USERS] set analytics all query";
export declare const SET_USERS_ANALYTICS_ALL_LOADING = "[USERS] set analytics all loading";
export declare const SET_USERS_MARKERS_DATA_MAP = "[USERS] set users listAll data map";
export declare const SET_SUMMARY_ACTIVE = "[USERS] set summary active";
export declare const SET_USERS_SUMMARY = "[USERS] set users summary";
export declare const SET_USERS_SUMMARY_LOADING = "[USERS] set summary loading";
export declare const SET_USERS_INDEX_PAGE = "[USERS] set user index page";
export declare const ADD_USERS_INDEX_ALL = "[USERS] add users index all";
export declare const SET_USERS_LIST_API_TYPE = "[USERS] set users list api type";
export declare class SetUserData implements Action {
    payload: IUserPlaceline | null;
    readonly type: string;
    constructor(payload: IUserPlaceline | null);
}
export declare class SetPlacelineId implements Action {
    payload: string | null;
    readonly type: string;
    constructor(payload: string | null);
}
export declare class TogglePlacelineId implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare class SetPlacelineQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class AddPlacelineQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class SetPlacelineLoading implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload: boolean | string);
}
export declare class SetUsersListId implements Action {
    payload: string | null;
    readonly type: string;
    constructor(payload: string | null);
}
export declare class ToggleUsersListId implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare class SetListQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class AddListQuery implements Action {
    payload: object;
    readonly type: string;
    constructor(payload: object);
}
export declare class ClearQueryKey implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare class SetUsersAnalyticsPage implements Action {
    payload: Page<IUserAnalytics>;
    readonly type: string;
    constructor(payload: Page<IUserAnalytics>);
}
export declare class SetUsersAnalyticsLoading implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class SetUsersIndexPage implements Action {
    payload: Page<IUser>;
    readonly type: string;
    constructor(payload: Page<IUser>);
}
export declare class AddUsersAnalyticsAll implements Action {
    payload: Page<IUserAnalytics>;
    readonly type: string;
    constructor(payload: Page<IUserAnalytics>);
}
export declare class SetUsersAnalyticsAll implements Action {
    payload: Page<IUserAnalytics>;
    readonly type: string;
    constructor(payload: Page<IUserAnalytics>);
}
export declare class SetUsersAnalyticsAllLoading implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class SetUsersIndexAll implements Action {
    payload: AllData<IUser>;
    readonly type: string;
    constructor(payload: AllData<IUser>);
}
export declare class SetUsersListApiType implements Action {
    payload: ApiType;
    readonly type: string;
    constructor(payload: ApiType);
}
export declare class SetUsersListDataMap implements Action {
    payload: (user) => any;
    readonly type: string;
    constructor(payload: (user) => any);
}
export declare class SetUsersMarkersDataMap implements Action {
    payload: (data) => any;
    readonly type: string;
    constructor(payload: (data) => any);
}
export declare class SetListActive implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload?: boolean | string);
}
export declare class SetMarkersActive implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload?: boolean | string);
}
export declare class SetSummaryActive implements Action {
    payload: boolean | string;
    readonly type: string;
    constructor(payload?: boolean | string);
}
export declare class SetUsersSummary implements Action {
    payload: IUserListSummary;
    readonly type: string;
    constructor(payload: IUserListSummary);
}
export declare class SetSummaryLoading implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare type All = SetUserData | SetPlacelineId | TogglePlacelineId | SetPlacelineQuery | AddPlacelineQuery | SetPlacelineLoading | SetUsersListId | ToggleUsersListId | SetListQuery | AddListQuery | ClearQueryKey | SetUsersAnalyticsPage | SetUsersAnalyticsLoading | SetUsersIndexPage | AddUsersAnalyticsAll | SetUsersAnalyticsAll | SetUsersAnalyticsAllLoading | SetUsersIndexAll | SetUsersSummary | SetUsersListApiType | SetUsersListDataMap | SetUsersMarkersDataMap | SetListActive | SetMarkersActive | SetSummaryActive | SetSummaryLoading;
