import { Observable, Subscription } from "rxjs";
import { IPageClientConfig } from "../../interfaces";
import { EntityItemClient } from "../../base/item-client";
import { IAccountUser } from "ht-models";
import { HtAccountUserApi } from "ht-api";
export declare class AccountUser extends EntityItemClient {
    query$: Observable<object>;
    id$: any;
    updateStrategy: string;
    pollDuration: number;
    store: any;
    data$: any;
    loading$: any;
    api$: (id, query) => Observable<IAccountUser>;
    constructor({dateParam, store, api}: IPageClientConfig<HtAccountUserApi>);
    getDefaultQuery(): {};
    setId(id: any): void;
    setLoading(loading: any): void;
    setData(data: any): void;
}
export declare const AccountUserClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & {
    new (...args: any[]): {
        getData$([id, query]: [any, any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([id, query]: [any, any]): Observable<any>;
        pollDuration: number;
        api$(id: string, query: object): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<{}>;
        getApiParams$(): Observable<[string, {}]>;
        query$: Observable<object>;
        getDefaultQuery(): object;
        id$: Observable<string>;
    };
} & typeof AccountUser;
