import { Observable, Subscription, BehaviorSubject } from "rxjs";
import { IPageClientConfig } from "../../interfaces";
import { Page, IMembership } from "ht-models";
import { HtAccountUserApi } from "ht-api";
export declare class MembershipsAll {
    query$: Observable<object>;
    updateStrategy: string;
    pollDuration: number;
    active$: BehaviorSubject<boolean>;
    api$: (id, query) => Observable<Page<IMembership>>;
    store: any;
    data$: any;
    id$: any;
    loading$: BehaviorSubject<string | boolean>;
    constructor({dateParam, store, api}: IPageClientConfig<HtAccountUserApi>);
    setActive(isActive: boolean): void;
    firstDataEffect(): void;
    getDefaultQuery(): {
        page_size: number;
    };
    setLoading(loading?: string | boolean): void;
    addData(data: any): void;
}
export declare const MemberShipsClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        addData(data: any): void;
    };
} & {
    new (...args: any[]): {
        getData$([id, query]: [any, any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([id, query]: [any, any]): Observable<any>;
        pollDuration: number;
        api$(id: string, query: object): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<{}>;
        getApiParams$(): Observable<[string, {}]>;
        query$: Observable<object>;
        getDefaultQuery(): object;
        id$: Observable<string>;
    };
} & typeof MembershipsAll;
