import { Observable } from "rxjs";
import { QueryLabel } from "../../interfaces";
import { DateRange } from "../../global/date-range";
import { ActionsGraph } from "./actions-graph";
import { ActionsList } from "./actions-list-client";
import { ActionsSummary } from "./actions-summary-client";
import { ActionsFilter } from "../../filters/actions-filter";
import { ActionsHeatmap } from "./actions-heatmap-client";
import { ActionsIndexAll } from "./actions-list-all-client";
import { HtActionsApi } from "ht-api";
export declare class HtActionsClient {
    api: HtActionsApi;
    graph: ActionsGraph;
    store: any;
    list: ActionsList;
    listAll: ActionsIndexAll;
    summary: ActionsSummary;
    heatmap: ActionsHeatmap;
    filters: ActionsFilter;
    constructor(config: IActionsClientConfig);
    private initEffects();
    setListAllFilter(query: any): void;
    readonly queryLabel$: Observable<QueryLabel[]>;
    readonly ordering$: Observable<{
        string: any;
        sign: number;
    }>;
    private getOrderingMod(ordering);
}
export declare const actionsClientFactory: (options?: Partial<IActionsClientConfig>) => HtActionsClient;
export interface IActionsClientConfig {
    dateRange: DateRange;
}
