import { Observable, Subscription } from "rxjs";
import { IActionStatusGraph } from "ht-models";
import { IAllowedQueryMap } from "ht-data";
import { IPageClientConfig } from "../../interfaces";
import { HtActionsApi } from "ht-api";
import { DateRange } from "../../global/date-range";
export declare class ActionsGraph {
    query$: Observable<object>;
    data$: Observable<IActionStatusGraph[] | null>;
    active$: Observable<boolean>;
    loading$: Observable<boolean>;
    api$: (query) => Observable<IActionStatusGraph[]>;
    updateStrategy: string;
    pollDuration: number;
    dateRange: DateRange;
    dataSub: Subscription;
    dateParam: string;
    store: any;
    constructor({dateRange, store, dateParam, api}: IPageClientConfig<HtActionsApi>);
    setActive(active?: boolean): void;
    setQuery(): void;
    getDefaultQuery(): {};
    setData(data: any): void;
    firstDataEffect(): void;
    setLoading(loading?: boolean | string): void;
    clearData(): void;
    destroy(): void;
}
export declare const ActionsGraphClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & {
    new (...args: any[]): {
        getData$([query]: [any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([query]: [any]): Observable<any>;
        pollDuration: number;
        api$(query: any): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<any>;
        getBaseQuery$(): Observable<{}>;
        getApiParams$(): Observable<any[]>;
        query$: Observable<object>;
        allowedQueryMap?: IAllowedQueryMap[];
        getDefaultQuery(): object;
        dateRange?: DateRange;
        dateParam?: string;
        active$?: Observable<boolean>;
    };
} & typeof ActionsGraph;
