import { EntityAllItemsClient } from "../../base/all-items.client";
import { Observable, Subscription } from "rxjs";
import { IAllowedQueryMap } from "ht-data";
import { IAction, Page } from "ht-models";
import { IPageClientConfig } from "../../interfaces";
import { DateRange } from "../../global/date-range";
import { HtActionsApi } from "ht-api";
export declare class ActionsIndexAll extends EntityAllItemsClient {
    loading$: Observable<boolean>;
    query$: Observable<object>;
    api$: (query) => Observable<Page<IAction>>;
    dataSub: Subscription;
    dataEntities$: any;
    dateParam: string;
    store: any;
    constructor({dateRange, store, dateParam, api}: IPageClientConfig<HtActionsApi>);
    setActive(isActive?: boolean): void;
    setQuery(query: any): void;
    addData(data: any): void;
    setData(data: any): void;
    setLoading(loading: any): void;
    clearQueryKey(key: string): void;
    setDataMap(mapFunc: any): void;
    clearData(): void;
}
export declare const ActionsIndexAllClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        addData(data: any): void;
    };
} & {
    new (...args: any[]): {
        getData$([query]: [any]): Observable<any>;
        getFirstData$([query]: [any]): Observable<any>;
        api$(query: any): Observable<Page<any>>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<any>;
        getBaseQuery$(): Observable<{}>;
        getApiParams$(): Observable<any[]>;
        query$: Observable<object>;
        allowedQueryMap?: IAllowedQueryMap[];
        getDefaultQuery(): object;
        dateRange?: DateRange;
        dateParam?: string;
        active$?: Observable<boolean>;
    };
} & typeof ActionsIndexAll;
