import { EntityListClient } from "../../base/list-client";
import { IPageClientConfig } from "../../interfaces";
import { Observable, Subscription } from "rxjs";
import { Page, IAction } from "ht-models";
import { IAllowedQueryMap } from "ht-data";
import { DateRange } from "../../global/date-range";
import { HtActionsApi } from "ht-api";
export declare class ActionsList extends EntityListClient {
    store: any;
    data$: Observable<Page<IAction>>;
    loading$: Observable<boolean | string>;
    dataArray$: Observable<IAction[] | null>;
    api$: (query) => Observable<Page<IAction>>;
    dataSub: Subscription;
    dateParam: string;
    defaultQuery: {
        ordering: string;
    };
    constructor({dateRange, store, dateParam, api}: IPageClientConfig<HtActionsApi>);
    getDefaultQuery(): {
        ordering: string;
    };
    setActive(active?: boolean): void;
    setLoading(loading: any): void;
    setData(data: any): void;
    addQuery(query: any): void;
    setQuery(query: any): void;
    clearQueryKey(key: string): void;
    clearData(): void;
}
export declare const ActionsListClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & {
    new (...args: any[]): {
        getData$([query]: [any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([query]: [any]): Observable<any>;
        pollDuration: number;
        api$(query: object): Observable<Page<any>>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<any>;
        getBaseQuery$(): Observable<{}>;
        getApiParams$(): Observable<any[]>;
        query$: Observable<object>;
        allowedQueryMap?: IAllowedQueryMap[];
        getDefaultQuery(): object;
        dateRange?: DateRange;
        dateParam?: string;
        active$?: Observable<boolean>;
    };
} & typeof ActionsList;
