import { EntityItemClient } from "../../base/item-client";
import { Observable, Subscription } from "rxjs";
import { IClientConfig } from "../../interfaces";
import { IGroup } from "ht-models";
import { HtGroupsApi } from "ht-api";
export declare class GroupsItem extends EntityItemClient {
    name: string;
    defaultQuery: {
        ordering: string;
    };
    updateStrategy: string;
    query$: Observable<object>;
    data$: Observable<never>;
    loading$: Observable<boolean>;
    getDefaultQuery(): {
        ordering: string;
    };
    api$: (id, query?) => Observable<IGroup>;
    setId(id: any): void;
    setData(data: any): void;
    setLoading(data: any): void;
    setQuery(): void;
    store: any;
    dataSub: Subscription;
    constructor({store, api}: IClientConfig<HtGroupsApi>);
    clearData(): void;
    destroy(): void;
}
export declare const GroupsItemClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & {
    new (...args: any[]): {
        getData$([id, query]: [any, any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([id, query]: [any, any]): Observable<any>;
        pollDuration: number;
        api$(id: string, query: object): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<{}>;
        getApiParams$(): Observable<[string, {}]>;
        query$: Observable<object>;
        getDefaultQuery(): object;
        id$: Observable<string>;
    };
} & typeof GroupsItem;
