import { IUserAnalytics, Page, AllData } from "ht-models";
import { IPageClientConfig } from "../../interfaces";
import { Observable, Subscription } from "rxjs";
import { EntityAllItemsClient } from "../../base/all-items.client";
import { IAllowedQueryMap } from "ht-data";
import { HtUsersApi } from "ht-api";
import { DateRange } from "../../global/date-range";
export declare class UsersAnalyticsListAll extends EntityAllItemsClient {
    data$: Observable<Page<IUserAnalytics>>;
    loading$: Observable<boolean>;
    id$: Observable<never>;
    allowedQueryKeys: string[];
    name: string;
    api$: (query) => Observable<Page<IUserAnalytics>>;
    defaultQuery: {};
    store: any;
    dataArray$: any;
    dataEntities$: Observable<AllData<any>>;
    allowedQueryMap: IAllowedQueryMap[];
    dataSub: Subscription;
    dateParam: string;
    constructor({dateRange, store, dateParam, api}: IPageClientConfig<HtUsersApi>);
    getDefaultQuery(): {};
    firstDataEffect(data: any): void;
    setActive(isActive?: boolean | string): void;
    addData(data: Page<IUserAnalytics>): void;
    setData(data: Page<IUserAnalytics>): void;
    setLoading(data: any): void;
    setDataMap(mapFunc: any): void;
    isValidMarker(marker: any): boolean;
    clearData(): void;
    destroy(): void;
}
export declare const UsersAnalyticsListAllClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        addData(data: any): void;
    };
} & {
    new (...args: any[]): {
        getData$([query]: [any]): Observable<any>;
        getFirstData$([query]: [any]): Observable<any>;
        api$(query: any): Observable<Page<any>>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<any>;
        getBaseQuery$(): Observable<{}>;
        getApiParams$(): Observable<any[]>;
        query$: Observable<object>;
        allowedQueryMap?: IAllowedQueryMap[];
        getDefaultQuery(): object;
        dateRange?: DateRange;
        dateParam?: string;
        active$?: Observable<boolean>;
    };
} & typeof UsersAnalyticsListAll;
