import { UsersPlaceline } from "./users-placeline-client";
import { IDateRange, QueryLabel } from "../../interfaces";
import { IUserPlaceline, Partial } from "ht-models";
import { UsersAnalytics } from "./users-analytics-client";
import { Observable } from "rxjs";
import { EntityClient } from "../../base/entity-client";
import { UsersAnalyticsListAll } from "./users-analytics-markers";
import { DefaultUsersFilter } from "../../filters/users-filter";
import { DateRange } from "../../global/date-range";
import { UsersHeatmap } from "./users-heatmap-client";
import { HtUsersApi } from "ht-api";
export declare class HtUsersClient extends EntityClient {
    options: IUsersClientConfig;
    analytics: UsersAnalytics;
    placeline: UsersPlaceline;
    analyticsAll: UsersAnalyticsListAll;
    filterClass: DefaultUsersFilter;
    list: UsersAnalytics;
    summary: any;
    listAll: any;
    heatmap: UsersHeatmap;
    _statusQueryArray: QueryLabel[];
    store: any;
    api: HtUsersApi;
    key$: any;
    showAll: boolean;
    dateRange: DateRange;
    constructor(options: IUsersClientConfig);
    getLoading$(): Observable<boolean>;
    statusQueryArray: QueryLabel[];
    setShowAll(showAll?: boolean): void;
    getInitialDateRange(range?: Partial<IDateRange>): IDateRange;
    listStatusOverview$(): any;
    listStatusChart$(queryLabels?: QueryLabel[]): Observable<{
        totalUsers: number;
        chart: {
            w: number;
            selected: boolean;
            value: any;
            label: string;
            values: string[];
            color?: string;
        }[];
        hasSelected: boolean;
    }>;
    readonly queryLabel$: Observable<QueryLabel[]>;
    readonly ordering$: Observable<{
        string: any;
        sign: number;
    }>;
    private getOrderingMod(ordering);
    getSegmentsStates(): any;
    getCurrentPlaceline$(): Observable<IUserPlaceline>;
    private initEffects();
    setListAllFilter(query: any): void;
    getListAllUpdateQuery$(overview: any, query: any): any;
}
export declare const usersClientFactory: (options?: Partial<IUsersClientConfig>) => HtUsersClient;
export interface IUsersClientConfig {
    dateRange: DateRange;
}
export interface IUsersSummaryData {
    totalUsers: number;
    hasSelected: boolean;
    chart: IUsersSummaryChart[];
}
export interface IUsersSummaryChart {
    label: string;
    color: string;
    selected: boolean;
    value: number;
    values: string[];
    w: number;
}
