import { Observable, Subscription } from "rxjs";
import { EntityItemClient } from "../../base/item-client";
import { IClientConfig } from "../../interfaces";
import { IUserPlaceline } from "ht-models";
import { HtUsersApi } from "ht-api";
export declare class UsersPlaceline extends EntityItemClient {
    name: string;
    updateStrategy: string;
    api$: (id, query) => Observable<IUserPlaceline>;
    store: any;
    data$: any;
    loading$: any;
    segmentsState$: any;
    segmentSelectedId$: any;
    segmentResetId$: any;
    actionId$: any;
    hasData$: any;
    constructor({store, api}: IClientConfig<HtUsersApi>);
    getQueryType(type: string): Observable<any>;
    setData(data: any): void;
    setLoading(data: any): void;
    setId(id: any): void;
    toggleId(userId: string): void;
    setQuery(query: any): void;
    setSegmentSelectedId(segmentId: any): void;
    setSegmentResetMapId(segmentId: string): void;
    getMapData$(): void;
    validQueryData([id, query]: [any, any]): boolean;
    clearData(): void;
}
export declare const UsersPlacelineClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & {
    new (...args: any[]): {
        getData$([id, query]: [any, any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([id, query]: [any, any]): Observable<any>;
        pollDuration: number;
        api$(id: string, query: object): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<{}>;
        getApiParams$(): Observable<[string, {}]>;
        query$: Observable<object>;
        getDefaultQuery(): object;
        id$: Observable<string>;
    };
} & typeof UsersPlaceline;
