import { Observable, Subscription } from "rxjs";
import { EntityListClient } from "../../base/list-client";
import { HtUsersApi } from "ht-api";
import { IPageClientConfig, QueryLabel } from "../../interfaces";
import { IUserListSummary } from "ht-models";
import { IAllowedQueryMap } from "ht-data";
import { DateRange } from "../../global/date-range";
import { DefaultUsersFilter } from "../../filters/users-filter";
export declare class UsersSummary extends EntityListClient {
    name: string;
    defaultQuery: {
        page_size: any;
    };
    updateStrategy: string;
    data$: Observable<IUserListSummary>;
    loading$: Observable<boolean>;
    store: any;
    allowedQueryMap: IAllowedQueryMap[];
    dataSub: Subscription;
    dateParam: string;
    api$: (query) => Observable<IUserListSummary>;
    filter: DefaultUsersFilter;
    showAll: boolean;
    constructor({dateRange, store, dateParam, api}: IPageClientConfig<HtUsersApi>);
    setActive(isActive?: boolean | string): void;
    setData(usersSummary: any): void;
    setLoading(data: any): void;
    setQuery(query: any): void;
    clearData(): void;
    destroy(): void;
    getSummaryChart$(queryLabels?: QueryLabel[]): Observable<object>;
    private listStatusOverview$();
}
export declare const UsersSummaryClient: {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & {
    new (...args: any[]): {
        getData$([query]: [any]): Observable<any>;
        updateStrategy: string;
        getFirstData$([query]: [any]): Observable<any>;
        pollDuration: number;
        api$(query: any): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getFirstData$(args: any): Observable<any>;
        firstDataEffect(any: any): void;
        api$(...args: any[]): Observable<any>;
    };
} & {
    new (...args: any[]): {
        getApiQuery$(): Observable<any>;
        getBaseQuery$(): Observable<{}>;
        getApiParams$(): Observable<any[]>;
        query$: Observable<object>;
        allowedQueryMap?: IAllowedQueryMap[];
        getDefaultQuery(): object;
        dateRange?: DateRange;
        dateParam?: string;
        active$?: Observable<boolean>;
    };
} & typeof UsersSummary;
