import { Store } from "./store/store";
import * as fromRoot from "./reducers";
import { HtBaseApi } from "ht-api";
import { DateRange } from "./global/date-range";
export declare const defaultListConfig: IListConfig;
export interface IDateRange {
    start: string;
    end: string;
}
export interface IListConfig {
    initialQuery?: object;
    isLive?: boolean;
}
export declare enum ApiType {
    index = "index",
    analytics = "analytics",
}
export interface QueryLabel {
    label: string;
    values: string[];
    value?: string;
    color?: string;
}
export interface IClientConfig<T = HtBaseApi> {
    store?: Store<fromRoot.State>;
    api: T;
}
export interface IPageClientConfig<T = HtBaseApi> extends IClientConfig<T> {
    dateRange?: DateRange;
    dateParam?: string;
}
