import { Observable, Subscription } from "rxjs";
import { Constructor } from "ht-models";
export interface IClientBase {
    getApiParams$(): Observable<any>;
    setLoading(loading: boolean | string): void;
    getData$(data: any): any;
    setData(data: any): void;
    validQueryData?(data: any[]): boolean;
}
export declare function clientSubMixin<TBase extends Constructor<IClientBase>>(Base: TBase): {
    new (...args: any[]): {
        dataSub: Subscription;
        init(): void;
        getApiParams$(): Observable<any>;
        setLoading(loading: string | boolean): void;
        getData$(data: any): any;
        setData(data: any): void;
        validQueryData?(data: any[]): boolean;
    };
} & TBase;
