import * as AccountDispatcher from "../dispatchers/accounts-dispatcher";
import { Page, IAccountUser, IMembership } from "ht-models";
import { MemoizedSelector } from "../store/selector";
export interface State {
    accountUser?: IAccountUser;
    membershipsAll?: Page<IMembership> | null;
    userId?: string | null;
    key: string;
    tempKey?: string | null;
}
export declare const initialState: State;
export declare function reducer(state: State, action: AccountDispatcher.All): State;
export declare const getAccountUser: (state: State) => IAccountUser;
export declare const getMembershipsAll: (state: State) => Page<IMembership>;
export declare const getKey: (state: State) => string;
export declare const getTempKey: (state: State) => string;
export declare const getUserId: (state: State) => string;
export declare const getCurrentKey: MemoizedSelector<State, string>;
