import * as ActionsDispatcher from "../dispatchers/actions-dispatcher";
import { IAction, IActionStatusGraph, Page, IActionsSummary, AllData } from "ht-models";
import { MemoizedSelector } from "../store/selector";
export interface State {
    list: Page<IAction> | null;
    listLoading: boolean | string;
    listQuery: object;
    listActive: string | boolean;
    listAll: AllData<IAction> | null;
    listAllLoading: boolean;
    listAllActive: boolean | string;
    listAllDataMap?: (data) => any;
    summary: IActionsSummary | null;
    summaryActive: boolean | string;
    summaryLoading: boolean;
    summaryQuery: object;
    graph: IActionStatusGraph[] | null;
    graphLoading: boolean;
    graphQuery: object;
    graphActive: boolean;
}
export declare const initialState: State;
export declare function actionsReducer(state: State, action: ActionsDispatcher.All): State;
export declare const getList: (state: State) => Page<IAction>;
export declare const getListLoading: (state: State) => string | boolean;
export declare const getListActive: (state: State) => string | boolean;
export declare const getListQuery: (state: State) => object;
export declare const getListAll: (state: State) => AllData<IAction>;
export declare const getListAllLoading: (state: State) => boolean;
export declare const getListAllActive: (state: State) => string | boolean;
export declare const getListAllDataMap: (state: State) => (data: any) => any;
export declare const getListAllFiltered: MemoizedSelector<State, any>;
export declare const getSummary: (state: State) => IActionsSummary;
export declare const getSummaryActive: (state: State) => string | boolean;
export declare const getSummaryQuery: (state: State) => object;
export declare const getSummaryLoading: (state: State) => boolean;
export declare const getGraph: (state: State) => IActionStatusGraph[];
export declare const getGraphQuery: (state: State) => object;
export declare const getGraphLoading: (state: State) => boolean;
export declare const getGraphActive: (state: State) => boolean;
