import * as UserDispatch from "../dispatchers/user-dispatcher";
import { IUserPlaceline, AllData, Page, IUser, IUserAnalytics, IUserListSummary } from "ht-models";
import { ApiType } from "../interfaces";
import { MemoizedSelector } from "../store/selector";
export interface State {
    userData?: IUserPlaceline | undefined | null;
    placelineId?: string | null;
    placelineQuery?: object;
    placelineLoading?: boolean;
    usersListActive: boolean | string;
    listQuery?: object;
    listId?: string | null;
    usersListDataMap?: (data) => any;
    usersAnalyticsPage?: Page<IUserAnalytics> | null;
    analyticsLoading?: boolean;
    usersMarkersActive: boolean | string;
    usersAnalyticsAll?: AllData<IUserAnalytics>;
    analyticsAllLoading?: boolean;
    usersMarkersDataMap?: (data) => any;
    usersSummaryActive: boolean | string;
    usersSummary?: IUserListSummary | null;
    summaryLoading?: boolean;
    usersIndexAll?: AllData<IUser>;
    usersIndexPage?: Page<IUser>;
    listApiType: ApiType;
}
export declare function usersReducer(state: State, action: UserDispatch.All): State;
export declare const getUserData: (state: State) => IUserPlaceline;
export declare const getPlacelineId: (state: State) => string;
export declare const getPlacelineQuery: (state: State) => object;
export declare const getPlacelineLoading: (state: State) => boolean;
export declare const getListActive: (state: State) => string | boolean;
export declare const getListId: (state: State) => string;
export declare const getListQuery: (state: State) => object;
export declare const getAnalyticsPage: (state: State) => Page<IUserAnalytics>;
export declare const getAnalyticsLoading: (state: State) => boolean;
export declare const getAnalyticsAll: (state: State) => AllData<IUserAnalytics>;
export declare const getAnalyticsAllLoading: (state: State) => boolean;
export declare const getMarkerDataMap: (state: State) => (data: any) => any;
export declare const getIndexAll: (state: State) => AllData<IUser>;
export declare const getIndexPage: (state: State) => Page<IUser>;
export declare const getListApiType: (state: State) => ApiType;
export declare const getMarkersActive: (state: State) => string | boolean;
export declare const getSummary: (state: State) => IUserListSummary;
export declare const getSummaryActive: (state: State) => string | boolean;
export declare const getSummaryLoading: (state: State) => boolean;
export declare const getAnalyticFilteredMarkers: MemoizedSelector<State, any>;
export declare const getIndexFilteredMarkers: MemoizedSelector<State, any>;
export declare const getIndexActive: MemoizedSelector<State, boolean>;
export declare const getAnalyticsActive: MemoizedSelector<State, string | boolean>;
export declare const getIndexMarkersActive: MemoizedSelector<State, boolean>;
export declare const getAnalyticsMarkersActive: MemoizedSelector<State, string | boolean>;
