import resolve from 'rollup-plugin-node-resolve'
import commonjs from 'rollup-plugin-commonjs'
import sourceMaps from 'rollup-plugin-sourcemaps'
import camelCase from 'lodash.camelcase'

const pkg = require('./package.json');

const libraryName = 'ht-client';

const globals = {
  'rxjs': 'rxjs',
  'rxjs/operators': 'rxjs.operators',
  'underscore': '_',
  'ht-api': 'htApi',
  'ht-utility': 'htUtility',
  'ht-data': 'htData',
  'moment-mini': 'moment',
  'ht-models': 'htModels',
  'leaflet': 'L',
  'leaflet.markercluster': 'L',
  "date-fns": 'dateFns'
}

export default {
  input: `dist/es/${libraryName}.js`,
  output: [
    { file: pkg.main, name: camelCase(libraryName), format: 'umd', globals},
    { file: pkg.module, format: 'es', globals},
  ],
  // sourcemap: true,
  // Indicate here external modules you don't wanna include in your bundle (i.e.: 'lodash')
  external: Object.keys(globals),
  // globals,
  watch: {
    include: 'dist/es/**',
  },
  plugins: [
    // Allow bundling cjs modules (unlike webpack, rollup doesn't understand cjs)
    commonjs(),
    // Allow node_modules resolution, so you can use 'external' to control
    // which external modules to include in the bundle
    // https://github.com/rollup/rollup-plugin-node-resolve#usage
    resolve(),

    // Resolve source maps to the original source
    // sourceMaps(),
  ],
};


